<?php 


class sf_zip_pack
{
    public function infosZip ($src, $data=true)
    {
        if (is_resource($zip = zip_open(realpath($src))))
        {
            while (($zip_entry = zip_read($zip)))
            {
                $path = zip_entry_name($zip_entry);
                if (zip_entry_open($zip, $zip_entry, "r"))
                {
                    $content[$path] = array (
                        'Ratio' => zip_entry_filesize($zip_entry) ? round(100-zip_entry_compressedsize($zip_entry) / zip_entry_filesize($zip_entry)*100, 1) : false,
                        'Size' => zip_entry_compressedsize($zip_entry),
                        'NormalSize' => zip_entry_filesize($zip_entry));
                    //if ($data)
                    //    $content[$path]['Data'] = zip_entry_read($zip_entry, zip_entry_filesize($zip_entry));
                    zip_entry_close($zip_entry);
                }
                else
                    $content[$path] = false;
            }
            zip_close($zip);
            return $content;
        }
        return false;
    }
    public function extractZip ($src, $dest)
    {
        $zip = new ZipArchive;
        if ($zip->open($src)===true)
        {
            $zip->extractTo($dest);
            $zip->close();
            return true;
        }
        return false;
    }
    public function makeZip ($src, $dest)
    {
        $zip = new ZipArchive;
        $src = is_array($src) ? $src : array($src);
        if ($zip->open($dest, ZipArchive::CREATE) === true)
        {
            foreach ($src as $item)
                if (file_exists($item))
                    $this->addZipItem($zip, realpath(dirname($item)).'/', realpath($item).'/');
            $zip->close();
            return true;
        }
        return false;
    }
    private function addZipItem ($zip, $racine, $dir)
    {
        if (is_dir($dir))
        {
            $zip->addEmptyDir(str_replace($racine, '', $dir));
            $lst = scandir($dir);
                array_shift($lst);
                array_shift($lst);
            foreach ($lst as $item)
                $this->addZipItem($zip, $racine, $dir.$item.(is_dir($dir.$item)?'/':''));
        }
        elseif (is_file($dir))
            $zip->addFile($dir, str_replace($racine, '', $dir));
    }
	
		
	function recursive_remove_directory($directory, $empty=FALSE)
	{
		 // if the path has a slash at the end we remove it here
		 if(substr($directory,-1) == '/')
		 {
			 $directory = substr($directory,0,-1);
		 }
	  
		 // if the path is not valid or is not a directory ...
		 if(!file_exists($directory) || !is_dir($directory))
		 {
			 // ... we return false and exit the function
			 return FALSE;
	  
		 // ... if the path is not readable
		 }elseif(!is_readable($directory))
		 {
			 // ... we return false and exit the function
			 return FALSE;
	  
		 // ... else if the path is readable
		 }else{
	  
			 // we open the directory
			 $handle = opendir($directory);
	  
			 // and scan through the items inside
			 while (FALSE !== ($item = readdir($handle)))
			 {
				 // if the filepointer is not the current directory
				 // or the parent directory
				 if($item != '.' && $item != '..')
				 {
					 // we build the new path to delete
					 $path = $directory.'/'.$item;
	  
					 // if the new path is a directory
					 if(is_dir($path)) 
					 {
						 // we call this function with the new path
						 $this->recursive_remove_directory($path);
	  
					 // if the new path is a file
					 }else{
						 // we remove the file
						 unlink($path);
					 }
				 }
			 }
			 // close the directory
			 closedir($handle);
	  
			 // if the option to empty is not set to true
			 if($empty == FALSE)
			 {
				 // try to delete the now empty directory
				 if(!rmdir($directory))
				 {
					 // return false if not possible
					 return FALSE;
				 }
			 }
			 // return success
			 return TRUE;
		 }
	}
}


?>